subroutine SPL2R(m,x,n,y,z,ind,ibx,iby,sl,sr,sd,su,sxy,zx,zy,zxy,xx,yy,spl)
!Построение интерполяционного бикубического сплайна 2-х переменных
!Исправленная программа "Splint2" из книги:
!Е.Шикин, А.Плис Кривые и поверхности на экране
!компьютера. М. "Диалог-МИФИ" 1996
integer, intent(in):: m, n, ind, ibx, iby
real, intent(in):: x(:), y(:), z(:), sl(:), sr(:), sd(:), su(:), sxy(:)
real, intent(in):: xx, yy
real, intent(inout):: zx(:), zy(:), zxy(:)
real, intent(out):: spl
real, allocatable:: zz(:), zu(:), zd(:)
real hx, hy, tx, ty, f(4), g(4), suma(4)
real sp, dsp, d2sp
integer mn1
integer i, j, ni, nj, k, km, kn
!begin
	if (m.lt.4.or.n.lt.4) then
		zx(:)=0.0; zy(:)=0.0; zxy(:)=0.0
		spl=0.0
		return
	end if
	if (ind == 0) then
		mn1=max(m,n)
		allocate (zz(mn1),zu(mn1),zd(mn1))
!C
		do j=1, n
			k=1+(j-1)*m; km=k+m-1
			call SPL1R(m,x,z(k:km),0,ibx,sl(j),sr(j),zx(k:km),xx,sp,dsp,d2sp)
		end do
!C
		if (iby.le.2) then
			call SPL1R(m,x,sd,0,ibx,sxy(1),sxy(2),zd(1:m),xx,sp,dsp,d2sp)
			call SPL1R(m,x,su,0,ibx,sxy(3),sxy(4),zu(1:m),xx,sp,dsp,d2sp)
		else
			zd(:)=0.0;  zu(:)=0.0
		end if
!C
		do i=1, m
			do j=1, n
				zz(j)=zx(i+(j-1)*m)
			end do
			k=1+(i-1)*n; kn=k+n-1
			call SPL1R(n,y,zz,0,iby,zd(i),zu(i),zxy(k:kn),xx,sp,dsp,d2sp)
		end do
!C
		do i=1, m
			do j=1, n
				zz(j)=z(i+(j-1)*m)
			end do
			k=1+(i-1)*n; kn=k+n-1
			call SPL1R(n,y,zz,0,iby,sd(i),su(i),zy(k:kn),xx,sp,dsp,d2sp)
		end do
!C
		deallocate (zz,zu,zd)
		spl=0.0
    else
!C
		do i=2, m
			ni=i
			if (x(i).gt.xx) exit
		end do
		i=ni-1
!C
		do j=2, n
			nj=j
			if (y(j).gt.yy) exit
		end do
		j=nj-1
!C
		hx=x(i+1)-x(i)
		tx=(xx-x(i))/hx
		hy=y(j+1)-y(j)
		ty=(yy-y(j))/hy
!C
		f(1)=(1-tx)**2*(1.+2.*tx)
		f(2)=tx**2*(3.-2.*tx)
		f(3)=tx*(1.-tx)**2*hx
		f(4)=-tx**2*(1.-tx)*hx
!C
		g(1)=(1-ty)**2*(1.+2.*ty)
		g(2)=ty**2*(3.-2.*ty)
		g(3)=ty*(1.-ty)**2*hy
		g(4)=-ty**2*(1.-ty)*hy
!C
		suma(1)=z(i+(j-1)*m)*f(1)+z(i+1+(j-1)*m)*f(2)+zx(i+(j-1)*m)*f(3)+zx(i+1+(j-1)*m)*f(4)
		suma(2)=z(i+j*m)*f(1)+z(i+1+j*m)*f(2)+zx(i+j*m)*f(3)+zx(i+1+j*m)*f(4)
		suma(3)=zy(j+(i-1)*n)*f(1)+zy(j+i*n)*f(2)+zxy(j+(i-1)*n)*f(3)+zxy(j+i*n)*f(4)
		suma(4)=zy(j+1+(i-1)*n)*f(1)+zy(j+1+i*n)*f(2)+zxy(j+1+(i-1)*n)*f(3)+zxy(j+1+i*n)*f(4)
!C
		spl=0.0
		do k=1, 4
			spl=spl+g(k)*suma(k)
		end do
    end if
!C
    return
end subroutine SPL2R